Description

On a newly installed centos 7 minimal system I have installed foreman 1.12.3 based on the official guide [[

https://theforeman.org/manuals/1.12/quickstart_guide.html]].

I have registered my foreman host with

puppet agent --test

And then wanted to create a provisioning setup with the command provided on the WEB UI

Command snippet is

foreman-installer \

--enable-foreman-proxy \

--foreman-proxy-tftp=true \

--foreman-proxy-dhcp=true \

--foreman-proxy-dhcp-interface=eth0.164 \

--foreman-proxy-dns=true \

--foreman-proxy-dns-interface=eth0.164 \

@

However it failed and in the log I found

@

[ERROR 2016-09-21 14:25:42 main] Errors encountered during run:

[ERROR 2016-09-21 14:25:42 main]  Evaluation Error: Error while evaluating a Function Call, Could not get the ip address from fact

ipaddress_eth0_164 at /usr/share/foreman-installer/modules/foreman_proxy/manifests/proxydhcp.pp:8:5 on node ...

[ERROR 2016-09-21 14:41:57 main] Errors encountered during run:

[ERROR 2016-09-21 14:41:57 main]  Evaluation Error: Error while evaluating a Function Call, Could not get the ip address from fact

ipaddress_eth0_164 at /usr/share/foreman-installer/modules/foreman_proxy/manifests/proxydns.pp:15:5 on node ...

@

Than I have checked the foreman WEB UI and puppet reported the fact with the ipaddress_eth0.164 key

I have also checked the code of /usr/share/foreman-installer/modules/foreman_proxy/manifests/proxydhcp.pp and

/usr/share/foreman-installer/modules/foreman_proxy/manifests/proxydns.pp and it seems it is replacing . (dot) with _ (underscore).

I have removed that replacement in both files and after that Provisioning setup went through fine.

It seems new puppet version has changed the format for this fact and the foreman puppet modules are still using the previous

syntax.

To me the fix was easy, however it should be tested what format puppet is using now for vlans and for aliases.

History

#1 - 09/21/2016 08:01 AM - Dominic Cleal

- Project changed from Foreman to Installer

- Subject changed from Provisioning setup command fails on proxydhcp.pp and proxydns.pp when main interface is in a tagged vlan to

foreman-proxy-dhcp-interface and dns-interface use wrong fact name for tagged vlans

- Category set to Foreman modules
#2 - 09/21/2016 08:08 AM - Ewoud Kohl van Wijngaarden

This was done because previous versions of facter behaved this way. I think we should try both facts in order to support both facter versions.
